#![doc(html_root_url="https://appcoreplatform.github.io/rustdoc/rust-cg/cg/")]
#![feature(rustc_private, plugin_registrar, quote, box_syntax, box_patterns)]


//! `cg` helps writing a compiler plugin.
//! You can use something simillar to quote_* for deriving traits.
//!



#[macro_use]
extern crate rustc;
#[macro_use]
extern crate syntax;

mod deriving;
mod util;



use rustc::plugin::Registry;
use syntax::ext::base::NormalTT;
use syntax::parse::token::intern;



#[plugin_registrar]
pub fn plugin_registrar(reg: &mut Registry) {
    reg.register_syntax_extension(intern("ext_path"), NormalTT(box deriving::expand_path, None, false));
    reg.register_syntax_extension(intern("ext_ty"), NormalTT(box deriving::expand_ty, None, false));
}
