pub use syntax::ext::base::ExtCtxt;
pub use syntax::codemap::Span;
pub use syntax::ptr::P;
pub use syntax::ast;
pub use syntax::ext::build::AstBuilder;


/// Generate a expression for ```vec![]```
pub fn vector_expr(cx: &mut ExtCtxt, sp: Span, exprs: Vec<P<ast::Expr>>) -> P<ast::Expr> {
	let arr_expr = cx.expr_vec(sp, exprs);
	let arr_expr = quote_expr!(cx, ::std::boxed::Box::new($arr_expr));

	quote_expr!(cx, <[_]>::into_vec($arr_expr))
}
